-- MUX_Timer package

package MUX_Timer is

   type DIGIT is mod 4;

    TIM6EN : constant := 2#1_0000#;

   CLK_MHZ : constant := 168;          -- I'm sure this is in the sys files too
   CLK_PRE : constant := CLK_MHZ / 2;  -- 84 MHz into prescaler
   PRE_US  : constant := 1;            -- us clock into timer
   CLK_US  : constant  := PRE_US * CLK_PRE; -- 5us clock into timer

   Blank : constant := 10;            -- next one after digit 9
   type SEG_INDEX is range 0..Blank;  -- digits 0..9 and Blank
   for SEG_INDEX'Size use 8;          -- represent as a byte

   type UPDATE_RATE is range 1..100;  -- display updates/sec
   type DISP_VAL is mod 10_000;       -- all >0 values that fit into 4 digits

   B_CLEAR : constant := 10;
   B_SS    : constant := 11;
   B_SLOW  : constant := 12;
   B_FAST  : constant := 13;

   procedure Init;
   procedure Enable;
   procedure Set_Val(Value : DISP_VAL; Blank_LZ : Boolean);
   procedure Set_Interrupt_Time(Per_Sec : UPDATE_RATE);

end MUX_Timer;
